#!/usr/local/bin/perl
# storefile - script to accept a file the user wants to load amd some comments
#     to be stored on a homepage in the directory. It will create a 
#     subdirectory if the dir_name specifies a non-existant directory
#
#     is called by form that is written by setup.cgi.It uses the html form type
#     <FORM ENCTYPE="multipart/form-data"  which is a Netscape feature
#     The message that is sent to the script by this form is of the format:
#   -----------------------------19020487825137        : a keyline
#   Content-Disposition: form-data; name="file_name"   : for each input field
#   \r\n                                               : blankline
#   <value for the input name                          : value for name
#   -----------------------------19020487825137        : a keyline
#   Content-Disposition: form-data; name="comments"   : for each input field
#   \r\n                                               : blankline
#   <value for the input name                          : value for comments
#   -----------------------------19020487825137        : a keyline
#   Content-Disposition: form-data; name="userfile"; filename="file"  :preceeds the input file
#   <content of input file>
#   \r\n                                               : blankline
#   -----------------------------19020487825137--      : a keyline with two trailing --

$URLbasedir= "/home/T11F/webflow/Akenti/akenti-docs";
unshift(@INC,"$URLbasedir/cgi-bin");
require 'definitions.pl';
#require 'wrhtaccess.pl';
#require 'createdir.pl';


if ($ENV{'REQUEST_METHOD'} ne 'POST')  {
    &report_status( "Error", "storefile","Not a POST method");
    exit;
}

system(umask 2);
$maxbuf=1024;
$file = 0;
@lines=();
$name="";
$value="";
$verbose = 1;

print "content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>storefile results</TITLE></HEAD><BODY BGCOLOr=#ffffff>\n";
$priv = $ENV{PRIVILEGE};
$dn = $ENV{SSL_CLIENT_DN};
if ($verbose) {
    print "<b>Debugging output for storefile</b><br>\n";
    print "$dn\n\t has rights: $priv<br>\n";
}
(@dnc) = split("/",$dn);
foreach $dnc (@dnc){
    if ($dnc =~ /CN/){
	($key,$CN)=split("=",$dnc);
    }
}
$cntlen = $ENV{CONTENT_LENGTH};
if ($verbose) {
    print "Content_length is $cntlen<br>\n";
}
$keyline = <STDIN>;
$keylength = length($keyline);
$cntlen -= $keylength;
while ( ($cntlen > $keylength+4)){
    if (&getblock($keyline)) {last;}
    &parseblock();
    if ($name eq "dir_name") {$dir_name = $value;}
    elsif ($name eq "file_name" ) {$file_name = $value; }
    elsif ($name eq "comments" ) { $comments = $value;}
}
if ($verbose){
    print "<br>dir_name is $dir_name<br>\n";
    print "file name is $file_name<br>\n";
    print "comments are $comments<br>\n";
}

if ($cntlen == $keylength+4) {
    &report_status("Error","storefile", "input file was empty");
    exit;
}
if (!( $priv =~ /add/) ){
    &report_status("Permission Denied", "storefile", "You do not have add permission in directory $dirname");
    exit;
}
if ($dir_name eq "") {
    &report_status( "Error", "storefile","No collection name given");
    exit;
}
$dir_name =~ s/^\///;   # get rid of any leading /
$dir_name =~ s/\/$//;   # get rid of any trailing /
@dirs = split("/",$dir_name);
$tagdir = "$URLbasedir";
foreach $dir (@dirs) {
    $tagdir .= "/$dir";
    if ( ! -d $tagdir) {
	if ($verbose ) { print "Creating directory $tagdir<br>\n"; }
	if (! mkdir($tagdir,0775)){
	    &report_status("Error", "storefile","Unable to create $tagdir");
	    exit;
	} else {
	    foreach $script ("storefile.cgi","delete.cgi","setup.cgi") {
		`ln -s "$URLbasedir/wforms/$script" "$tagdir/$script"`;
	    }
	}
    }
}

$fullname = "$tagdir/$file_name"; 

# make sure that the file does not already exist 

if (-e $fullname)
{
    $nb=1;
    while (-e $fullname.$nb) { $nb ++; }
    $fullname = "$fullname.$nb";
    $file_name = "$file_name.$nb";
 }

if ($verbose) {
    print "File length is $cntlen keylength is $keylength fullname is $fullname<br>\n";
}
open (UFILE, ">$fullname");
while ($cntlen > $keylength+4){
    $readlen = (($cntlen -$keylength-4) >= $maxbuf) ? $maxbuf : $cntlen -$keylength-4;
    $readlen = read (STDIN, $buf, $readlen);
    $cntlen -= $readlen;
    $offset=0;
    while ($readlen){
	$written = syswrite(UFILE, $buf, $readlen, $offset); 
	die "storefile: system write error: $!\n"
	    unless defined $written;
	$readlen -= $written;
	$offset += $written;
    }
}
close UFILE;

if (-e "$tagdir/$INDEX") {
    open (NINDEX, ">$tagdir/new.index");
    open (OINDEX, "$tagdir/$INDEX");
    while (<OINDEX>) {
	if ( /Delete selected files/) {
	    last;
	}
	print NINDEX $_;
    }
    close OINDEX;
} else {
     open (NINDEX, ">$tagdir/new.index");
     $a = <<TEXT;
     <HTML><HEAD>
     <TITLE>Index for $dir_name</TITLE>
     </HEAD>
     <BODY bgcolor=#ffffff>
     <H1>Index for $dir_name</H1>
     <HR><BR>
     <FORM METHOD=get ACTION="/$dir_name/setup.cgi">
     <INPUT TYPE=hidden NAME=dir_name VALUE="$dir_name">
    <h2>Load files to this directory
    <INPUT TYPE=submit NAME=load VALUE="Load file"></h2>

TEXT
    print NINDEX $a;
 }
$date = `date`;
$a = <<TEXT;
<a href="/$dir_name/$file_name"><B>$file_name</B></a>&nbsp;&nbsp;&nbsp;
<INPUT TYPE=checkbox NAME=delete_file VALUE=$file_name>delete
<br>
 -- Loaded on $date by $CN<BR><BR>
$comments
<BR><BR>
<b><INPUT TYPE=submit NAME=action value="Delete selected files"><b>
</FORM></BODY></HTML>
TEXT
    print NINDEX $a;
close NINDEX;

`rm "$tagdir/$INDEX"`;
`mv "$tagdir/new.index" "$tagdir/$INDEX"`;
    

print "<br>Message from script create_tags:<br>\n";
print "Successfully created file $fullname<br>\n";

print "<b><a href=\"/$dir_name/$INDEX\">homepage for $dir_name</a>\n";
print "</BODY></HTML>\n";


# ===========================================================================
# getblock($key)
# getblock ($key): Read from STDIN until the next line consisting of $key
#                  is reached. Drop any blank lines and the keyline. The
#                  data is returned in the @lines array

sub getblock
{
    local ($key) = @_;
    local ($bof) = 0;
    @lines = ();
    while ( $cntlen > $keylength+4){ #to skip the last blank line and keyline--
	$line = <STDIN>;
	$cntlen -= length($line);
	if ($verbose) { print "$cntlen: $line<br>";}
	if ($line =~ /^\s*$/) {  next; }
	if ($line =~ /userfile/) {
	    $bof = 1;
	    push (@lines,$line);
	    $line = <STDIN>;
	    $cntlen -= length($line);
	    if ($verbose) { print "$cntlen: $line<br>";}
	    if ($line =~ /^\s*$/) { last; }
	    elsif ($line =~ /Content-Type/) {
		 push (@lines,$line);
		# read one more blank line
		 $line = <STDIN>; $cntlen -= length($line);
		 if ($verbose) { print "$cntlen: $line<br>";}
		 last;
	     }
	}
	if ($line eq $key) { last; }
	push (@lines,$line);
    }
    print "next block is: <br>\n";
    foreach $line (@lines){
	print "$line <br>";
    }
    return ($bof);
}

# ===========================================================================
# parseblock()
#   parses the @lines array and returns the $name and $value

sub parseblock
{
    $value = ""; $name = "";
    foreach $line (@lines){
	chop ($line);
	if ($line =~ /^Content-Disposition/){
	    # assume line is Content-Disposition: form-data; name="<key_name>" [; file="<input_filename>"
	    $line =~ s/^Con.*data;\s*//;
	    ($key,$name) = split(/=/,$line);
	    if ($key eq "name") { 
		$name =~ s/\s*"//; # drop spaces before the quotes
	        $name =~ s/".*$//; # drop quotes, trailing spaces and userfilename
		if ($name eq "userfile" ) {return;}
	    }
	    $space="";
	}
	else {
	    $line =~ s/\s*$//;    # drop trailing whitespace and newline
	    $value .= $space . &unescape($line); 
	    $space = " ";
	}
    }
}


# ===========================================================================
# unescape(): Return the passed URL after replacing all %NN escaped chars
#             with their actual character equivalents.

sub unescape
{
    local($url) = @_;
 
    $url =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C",hex($1))/ge;
    return $url;
}
 
